----------------------------------------
-- ELECTROPONG -------------------------
----------------------------------------

-------------------------------------------
-- COLORES --------------------------------
-------------------------------------------
----------------------------  R    V    A
 local  blanco   = Color.new( 255, 255, 255)
 local  rojo     = Color.new( 255, 100, 100)
 local  verde    = Color.new(   0, 255,   0)
 local  azul     = Color.new( 100, 100, 255)
 local  amarillo = Color.new( 255, 255,   0)
 local  morado   = Color.new( 255,   0, 255)
 local  verdoso  = Color.new(   0, 255, 255)
 local  gris     = Color.new( 127, 127, 127)
 local  negro    = Color.new(   0,   0,   0)
 local fuente_p = Font.createMonoSpaced()
 fuente_p:setPixelSizes(0, 16)
 local fuente_m = Font.createMonoSpaced()
 fuente_m:setPixelSizes(0, 20)
-------------------------------------------
-- FIN COLORES ----------------------------
-------------------------------------------

------------------------------------------------------
-- SONIDOS -------------------------------------------
------------------------------------------------------
 local explosion = Sound.load ("./Comun/explosion.wav",false)
 local saque     = Sound.load ("./Comun/saque.wav",false)
 local gol       = Sound.load ("./Comun/gol.wav",false)
 local bombbeep  = Sound.load ("./Comun/bombbeep.wav",false)
 local tiro_1    = Sound.load ("./Comun/tiro_1.wav",false)
 local tiro_2    = Sound.load ("./Comun/tiro_2.wav",false)
 local fire_1    = Sound.load ("./Comun/disparo_1.wav",false)
 local fire_2    = Sound.load ("./Comun/disparo_2.wav",false)
 local musica_1 
------------------------------------------------------
-- FIN SONIDOS ---------------------------------------
------------------------------------------------------

---------------------------------------------------------------------
-- VARIABLES --------------------------------------------------------
---------------------------------------------------------------------
local oldNivel = 0
local fo = 1 ; local fo1 = 1 ; local fo2 = 1 ; local fo3 = 1 ; local fo4 = 1
local tiempo = Timer.new()
local tiempo_partida = 120
local tiempo_bolas = Timer.new()
local tiempo_final = Timer.new()
local disp_1 = Timer.new() ; local disp_2 = Timer.new() 
local xd    ; local yd
local xp    ; local yp
local xdabs ; local ydabs
local d     ; local dd ; local xdyd
local atc_n ; local atc_m
local atx_n ; local aty_n
local atx_m ; local aty_m
local cuenta_particulas = 0
local bola = 6
local pad = Controls.read()
local oldpad = Controls.read()
local jugador_1 = 0 ; local jugador_2 = 0
local power_1 = 0   ; local power_2 = 0
local disparo_1 = false   ; local disparo_2 = false
local pausa_disp_1 = true ; local pausa_disp_2 = true

local fuego_1 = false
local bala_1  = false
local bala_1_x = 0
local bala_1_y = 0
local repe_10 = false
local cuenta_repe_10 = 0
local xy_bala_1 = 0
local x_bala_1 = 0
local y_bala_1 = 0
local n_balas_1 = 10

local fuego_2 = false
local bala_2  = false
local bala_2_x = 0
local bala_2_y = 0
local repe_11 = false
local cuenta_repe_11 = 0
local xy_bala_2 = 0
local x_bala_2 = 0
local y_bala_2 = 0
local n_balas_2 = 10

local fin = false
local fin_partida = false
local repe_1 = false ; local repe_2 = false ; local repe_3 = false ; local repe_4 = false
local repe_5 = false ; local repe_6 = false ; local repe_7 = false ; local repe_8 = false
local repe_9 = false

local cuenta_repe_1 = 0 ; local cuenta_repe_2 = 0 ; local cuenta_repe_3 = 0 ; local cuenta_repe_4 = 0
local cuenta_repe_5 = 0 ; local cuenta_repe_6 = 0 ; local cuenta_repe_7 = 0 ; local cuenta_repe_8 = 0 
local cuenta_repe_9 = 0
local x_bomb = 0 ; local y_bomb = 0 ; local bomb = 0 ; local w = 1
local particula = {}
local x = 0 
local y = 0
local xv = 0
local yv = 0
local m  = 0
local p  = 1
local accion = true
local mobil  = true
local repulsion = 1000
local rep_1 = 4000
local rep_2 = 4000
local n_minas = 14
local num_bolas = 6
local n_particula = 14
local tiempo_disparo_1 = 1000
local tiempo_disparo_2 = 1000
local fondo = {} ; local paisaje ; local bala = {}
local j1 = {}    ; local j2 = {}
local a1 = {}    ; local a2 = {}      ; local a3 = {}      ; local a4 = {}
local bumb = {}  ; local barrera = {} ; local vortice = {}
---------------------------------------------------------------------
-- FIN VARIABLES ----------------------------------------------------
---------------------------------------------------------------------


------------------------------------------------------------------------------------------------
-- FUNCIONES -----------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------
local function funcion_cargar_imagenes()
  fondo[1] = Image.load("./Nivel_"..Nivel.."/cargando.png")
  screen:blit(0,0,fondo[1]) 
  screen.flip()
  screen:blit(0,0,fondo[1]) 
  screen.flip()

  fondo[1] = Image.load("./Nivel_"..Nivel.."/sprites.png")
  paisaje  = Image.load("./Nivel_"..Nivel.."/paisaje.png"); x = 400 ; y = 0
  for n = 1, 6 do bala[n] = Image.createEmpty(6,6) ; bala[n]:blit(0, 0, fondo[1], x, y, 6, 6) ; x = x + 6 end ; x = 0 ; y = 0
  for n = 1, 12 do j1[n] = Image.createEmpty(30,30) ; j1[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end ; x = 0 ; y = y + 30 
  for n = 1, 12 do j2[n] = Image.createEmpty(30,30) ; j2[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end ; x = 0 ; y = y + 30
  if     Nivel == 1 then
    for n = 1, 6 do a1[n] = Image.createEmpty(20,20) ; a1[n]:blit(0, 0, fondo[1], x, y, 20, 20) ; x = x + 20 end ; x = 0 ; y = y + 20 
    for n = 1, 6 do a2[n] = Image.createEmpty(16,16) ; a2[n]:blit(0, 0, fondo[1], x, y, 16, 16) ; x = x + 16 end ; x = 0 ; y = y + 16
    for n = 1, 6 do a4[n] = Image.createEmpty(30,30) ; a4[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end ; x = 0 ; y = y + 30
    for n = 1, 6 do a3[n] = Image.createEmpty(60,60) ; a3[n]:blit(0, 0, fondo[1], x, y, 60, 60) ; x = x + 60 end
  elseif Nivel == 2 then
    for n = 1, 6 do a1[n] = Image.createEmpty(20,20) ; a1[n]:blit(0, 0, fondo[1], x, y, 20, 20) ; x = x + 20 end ; x = 0 ; y = y + 20 
    for n = 1, 6 do a2[n] = Image.createEmpty(16,16) ; a2[n]:blit(0, 0, fondo[1], x, y, 16, 16) ; x = x + 16 end ; x = 0 ; y = y + 16
    for n = 1, 6 do a4[n] = Image.createEmpty(30,30) ; a4[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end ; x = 0 ; y = y + 30
    for n = 1, 6 do a3[n] = Image.createEmpty(60,60) ; a3[n]:blit(0, 0, fondo[1], x, y, 60, 60) ; x = x + 60 end
  elseif Nivel == 3 then
    for n = 1, 6 do a1[n] = Image.createEmpty(20,20) ; a1[n]:blit(0, 0, fondo[1], x, y, 20, 20) ; x = x + 20 end ; x = 0 ; y = y + 20 
    for n = 1, 6 do a2[n] = Image.createEmpty(16,16) ; a2[n]:blit(0, 0, fondo[1], x, y, 16, 16) ; x = x + 16 end ; x = 0 ; y = y + 16
    for n = 1, 6 do a4[n] = Image.createEmpty(30,30) ; a4[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end ; x = 0 ; y = y + 30
    for n = 1, 6 do a3[n] = Image.createEmpty(60,60) ; a3[n]:blit(0, 0, fondo[1], x, y, 60, 60) ; x = x + 60 end
  elseif Nivel == 4 then
    for n = 1, 6 do a1[n] = Image.createEmpty(60,60) ; a1[n]:blit(0, 0, fondo[1], x, y, 60, 60) ; x = x + 60 end ; x = 0 ; y = y + 60 
    for n = 1, 6 do a2[n] = Image.createEmpty(60,60) ; a2[n]:blit(0, 0, fondo[1], x, y, 60, 60) ; x = x + 60 end ; x = 0 ; y = y + 60 
    for n = 1, 6 do a3[n] = Image.createEmpty(60,60) ; a3[n]:blit(0, 0, fondo[1], x, y, 60, 60) ; x = x + 60 end ; x = 0 ; y = y + 60 
    for n = 1, 6 do a4[n] = Image.createEmpty(30,30) ; a4[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end
  elseif Nivel == 5 then
    for n = 1, 6 do a1[n] = Image.createEmpty(20,20) ; a1[n]:blit(0, 0, fondo[1], x, y, 20, 20) ; x = x + 20 end ; x = 0 ; y = y + 20 
    for n = 1, 6 do a2[n] = Image.createEmpty(16,16) ; a2[n]:blit(0, 0, fondo[1], x, y, 16, 16) ; x = x + 16 end ; x = 0 ; y = y + 16
    for n = 1, 6 do a4[n] = Image.createEmpty(30,30) ; a4[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end ; x = 0 ; y = y + 30
    for n = 1, 6 do a3[n] = Image.createEmpty(60,60) ; a3[n]:blit(0, 0, fondo[1], x, y, 60, 60) ; x = x + 60 end
  elseif Nivel == 6 then
    for n = 1, 6 do a1[n] = Image.createEmpty(20,20) ; a1[n]:blit(0, 0, fondo[1], x, y, 20, 20) ; x = x + 20 end ; x = 0 ; y = y + 20 
    for n = 1, 6 do a2[n] = Image.createEmpty(16,16) ; a2[n]:blit(0, 0, fondo[1], x, y, 16, 16) ; x = x + 16 end ; x = 0 ; y = y + 16
    for n = 1, 6 do a4[n] = Image.createEmpty(30,30) ; a4[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end ; x = 0 ; y = y + 30
    for n = 1, 6 do a3[n] = Image.createEmpty(60,60) ; a3[n]:blit(0, 0, fondo[1], x, y, 60, 60) ; x = x + 60 end
  elseif Nivel == 7 then
    for n = 1, 6 do a1[n] = Image.createEmpty(20,20) ; a1[n]:blit(0, 0, fondo[1], x, y, 20, 20) ; x = x + 20 end ; x = 0 ; y = y + 20 
    for n = 1, 6 do a2[n] = Image.createEmpty(16,16) ; a2[n]:blit(0, 0, fondo[1], x, y, 16, 16) ; x = x + 16 end ; x = 0 ; y = y + 16
    for n = 1, 6 do a4[n] = Image.createEmpty(30,30) ; a4[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end ; x = 0 ; y = y + 30
    for n = 1, 6 do a3[n] = Image.createEmpty(60,60) ; a3[n]:blit(0, 0, fondo[1], x, y, 60, 60) ; x = x + 60 end
  elseif Nivel == 8 then
    for n = 1, 6 do a1[n] = Image.createEmpty(20,20) ; a1[n]:blit(0, 0, fondo[1], x, y, 20, 20) ; x = x + 20 end ; x = 0 ; y = y + 20 
    for n = 1, 6 do a2[n] = Image.createEmpty(16,16) ; a2[n]:blit(0, 0, fondo[1], x, y, 16, 16) ; x = x + 16 end ; x = 0 ; y = y + 16
    for n = 1, 6 do a4[n] = Image.createEmpty(30,30) ; a4[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end ; x = 0 ; y = y + 30
    for n = 1, 6 do a3[n] = Image.createEmpty(60,60) ; a3[n]:blit(0, 0, fondo[1], x, y, 60, 60) ; x = x + 60 end
  elseif Nivel == 9 then
    for n = 1, 6 do a1[n] = Image.createEmpty(20,20) ; a1[n]:blit(0, 0, fondo[1], x, y, 20, 20) ; x = x + 20 end ; x = 0 ; y = y + 20 
    for n = 1, 6 do a2[n] = Image.createEmpty(16,16) ; a2[n]:blit(0, 0, fondo[1], x, y, 16, 16) ; x = x + 16 end ; x = 0 ; y = y + 16
    for n = 1, 6 do a4[n] = Image.createEmpty(30,30) ; a4[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end ; x = 0 ; y = y + 30
    for n = 1, 6 do a3[n] = Image.createEmpty(30,30) ; a3[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end
  elseif Nivel == 10 then
    for n = 1, 6 do a1[n] = Image.createEmpty(30,30) ; a1[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end ; x = 0 ; y = y + 30 
    for n = 1, 6 do a2[n] = Image.createEmpty(30,30) ; a2[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end ; x = 0 ; y = y + 30 
    for n = 1, 6 do a3[n] = Image.createEmpty(30,30) ; a3[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end ; x = 0 ; y = y + 30 
    for n = 1, 6 do a4[n] = Image.createEmpty(30,30) ; a4[n]:blit(0, 0, fondo[1], x, y, 30, 30) ; x = x + 30 end
  end
  fondo[1]   = Image.load("./Comun/explosion.png") ; w = 1 ; x = 0 ; y = 0
  for m = 1, 4 do 
      for n = 1, 4 do 
          bumb[w] = Image.createEmpty(60,60) ; bumb[w]:blit(0, 0, fondo[1], x, y, 60, 60) 
          x = x + 60 ; w = w + 1 end x = 0 ; y = y + 60 end
  fondo[1]   = Image.load("./Comun/barrera.png") ; w = 1 ; x = 0 ; y = 0
  for m = 1, 3 do
      for n = 1, 3 do 
          barrera[w] = Image.createEmpty(80,80) ; barrera[w]:blit(0, 0, fondo[1], x, y, 80, 80) 
          x = x + 80 ; w = w + 1 end x = 0 ; y = y + 80 end
  fondo[1]   = Image.load("./Comun/vortice.png") ;  x = 0 ; y = 0
  for n = 1, 4 do 
      vortice[n] = Image.createEmpty(128,128) ; vortice[n]:blit(0, 0, fondo[1], x, y, 128, 128) 
      x = x + 128  end
  fondo[1] = Image.load("./Comun/fondo_1.png") ; fondo[2] = Image.load("./Comun/fondo_2.png")
  fondo[3] = Image.load("./Comun/fondo_3.png") ; fondo[4] = Image.load("./Comun/fondo_4.png")
  fondo[5] = Image.load("./Comun/fondo_5.png") ; fondo[6] = Image.load("./Comun/fondo_6.png")

  screen:fillRect(45, 8, 395, 88, negro)
  screen:fontPrint( fuente_p , 55, 28, "X -------------> Campo Gravitatorio." , amarillo )
  screen:fontPrint( fuente_p , 55, 42, "O -------------> Disparo, 30 Balas." , amarillo )
  screen:fontPrint( fuente_p , 55, 56, "Select --------> Menu PAUSA." , amarillo )
  screen:fontPrint( fuente_p , 55, 70, "Start  --------> Menu PAUSA." , amarillo )
  screen:fontPrint( fuente_p , 55, 84, "PAD/Analogico -> Control J. ROJO." , amarillo )

  screen:fillRect(165, 202, 140, 34, negro)
  screen:fontPrint( fuente_m , 175, 224, "VIDAS -> " .. Vidas , amarillo )

  screen:fillRect(165, 238, 140, 30, negro)
  screen:fontPrint( fuente_m , 170, 260, "- Pulse X -" , amarillo )

  screen.flip()
  SoundSystem.SFXVolume(128) ; Music.volume(60)  -- 0 a 128 max
  screen.waitVblankStart(10)
  Music.playFile("./Nivel_"..Nivel.."/musica.it", true)
  screen.waitVblankStart(10)

  repeat
    pad = Controls.read()
    screen.waitVblankStart(2)
  until pad:cross()

end
--------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------
local function generar_particulas()
  if Nivel == 1 then
    tiempo_partida   = 200 ; tiempo_disparo_1 = 1000 ; tiempo_disparo_2 = 1000
    rep_1 = 4000   ; rep_2 = 4000 ; n_minas = 14   ; num_bolas = 2 ;  n_balas_1 = 30 ; n_balas_2 = 30
    particula[1] = { x=10 , y=262, xv=0, yv=0, m=4000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[2] = { x=470, y= 10, xv=0, yv=0, m=4000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[3] = { x= 10, y= 10, xv=0, yv=0, m=4000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[4] = { x=470, y=262, xv=0, yv=0, m=4000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[5] = { x=240, y=136, xv=0, yv=0, m=rep_1 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[6] = { x=240, y=136, xv=0, yv=0, m=rep_2 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[7] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[8] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[9] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[10]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[11]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[12]= { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 8, tt = 30}
    particula[13]= { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 8, tt = 30}
    particula[14]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
  elseif Nivel == 2 then
    tiempo_partida = 200 ; tiempo_disparo_1 = 1000 ; tiempo_disparo_2 = 1000
    rep_1 = 4000   ; rep_2 = 4000 ; n_minas = 14   ; num_bolas = 3 ; n_balas_1 = 30 ; n_balas_2 = 30
    particula[1] = { x=10 , y=262, xv=0, yv=0, m=4000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[2] = { x=470, y= 10, xv=0, yv=0, m=4000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[3] = { x= 10, y= 10, xv=0, yv=0, m=4000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[4] = { x=470, y=262, xv=0, yv=0, m=4000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[5] = { x=240, y=136, xv=0, yv=0, m=rep_1 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[6] = { x=240, y=136, xv=0, yv=0, m=rep_2 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[7] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[8] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[9] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[10]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[11]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[12]= { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 8, tt = 30}
    particula[13]= { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 8, tt = 30}
    particula[14]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
  elseif Nivel == 3 then
    tiempo_partida   = 200 ; tiempo_disparo_1 = 1000 ; tiempo_disparo_2 = 1000
    rep_1 = 4000   ; rep_2 = 5000 ; n_minas = 14   ; num_bolas = 3 ; n_balas_1 = 30 ; n_balas_2 = 30
    particula[1] = { x=10 , y=262, xv=0, yv=0, m=4000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[2] = { x=470, y= 10, xv=0, yv=0, m=4000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[3] = { x= 10, y= 10, xv=0, yv=0, m=4000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[4] = { x=470, y=262, xv=0, yv=0, m=4000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[5] = { x=240, y=136, xv=0, yv=0, m=rep_1 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[6] = { x=240, y=136, xv=0, yv=0, m=rep_2 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[7] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[8] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[9] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[10]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[11]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[12]= { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 8, tt = 30}
    particula[13]= { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 8, tt = 30}
    particula[14]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
  elseif Nivel == 4 then
    tiempo_partida   = 200 ; tiempo_disparo_1 = 1000 ; tiempo_disparo_2 = 1000
    rep_1 = 4000   ; rep_2 = 5000 ; n_minas = 14   ; num_bolas = 3 ; n_balas_1 = 30 ; n_balas_2 = 30
    particula[1] = { x=10 , y=262, xv=0, yv=0, m=4000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[2] = { x=470, y= 10, xv=0, yv=0, m=4000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[3] = { x= 10, y= 10, xv=0, yv=0, m=4000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[4] = { x=470, y=262, xv=0, yv=0, m=4000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[5] = { x=240, y=136, xv=0, yv=0, m=rep_1 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15} 
    particula[6] = { x=240, y=136, xv=0, yv=0, m=rep_2 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[7] = { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 3, tt = 30}
    particula[8] = { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 3, tt = 30}
    particula[9] = { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 3, tt = 30}
    particula[10]= { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 3, tt = 30}
    particula[11]= { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 3, tt = 30}
    particula[12]= { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 3, tt = 30}
    particula[13]= { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 3, tt = 30}
    particula[14]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
  elseif Nivel == 5 then
    tiempo_partida   = 200 ; tiempo_disparo_1 = 1000 ; tiempo_disparo_2 = 1000
    rep_1 = 4000   ; rep_2 = 6000 ; n_minas = 14   ; num_bolas = 4 ; n_balas_1 = 30 ; n_balas_2 = 30
    particula[1] = { x=10 , y=262, xv=0, yv=0, m=5000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[2] = { x=470, y= 10, xv=0, yv=0, m=4000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[3] = { x= 10, y= 10, xv=0, yv=0, m=5000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[4] = { x=470, y=262, xv=0, yv=0, m=4000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[5] = { x=240, y=136, xv=0, yv=0, m=rep_1 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[6] = { x=240, y=136, xv=0, yv=0, m=rep_2 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[7] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[8] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[9] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[10]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[11]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[12]= { x=240, y=136, xv=0, yv=0, m=4000  , p= 1, accion=false, mobil=true , puntos = 8, tt = 30}
    particula[13]= { x=240, y=136, xv=0, yv=0, m=4000  , p= 1, accion=false, mobil=true , puntos = 8, tt = 30}
    particula[14]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
  elseif Nivel == 6 then
    tiempo_partida   = 200 ; tiempo_disparo_1 = 1500 ; tiempo_disparo_2 = 1000
    rep_1 = 4000   ; rep_2 = 7000 ; n_minas = 14   ; num_bolas = 4 ; n_balas_1 = 30 ; n_balas_2 = 30
    particula[1] = { x=10 , y=262, xv=0, yv=0, m=5000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[2] = { x=470, y= 10, xv=0, yv=0, m=4000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[3] = { x= 10, y= 10, xv=0, yv=0, m=5000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[4] = { x=470, y=262, xv=0, yv=0, m=4000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[5] = { x=240, y=136, xv=0, yv=0, m=rep_1 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[6] = { x=240, y=136, xv=0, yv=0, m=rep_2 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[7] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[8] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[9] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[10]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[11]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[12]= { x=240, y=136, xv=0, yv=0, m=4000  , p= 1, accion=false, mobil=true , puntos = 8, tt = 30}
    particula[13]= { x=240, y=136, xv=0, yv=0, m=4000  , p= 1, accion=false, mobil=true , puntos = 8, tt = 30}
    particula[14]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
  elseif Nivel == 7 then
    tiempo_partida   = 200 ; tiempo_disparo_1 = 1500 ; tiempo_disparo_2 = 1000
    rep_1 = 4000   ; rep_2 = 8000 ; n_minas = 14   ; num_bolas = 4 ; n_balas_1 = 30 ; n_balas_2 = 30
    particula[1] = { x=10 , y=262, xv=0, yv=0, m=6000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[2] = { x=470, y= 10, xv=0, yv=0, m=4000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[3] = { x= 10, y= 10, xv=0, yv=0, m=6000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[4] = { x=470, y=262, xv=0, yv=0, m=3000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[5] = { x=240, y=136, xv=0, yv=0, m=rep_1 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[6] = { x=240, y=136, xv=0, yv=0, m=rep_2 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[7] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[8] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[9] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[10]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[11]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[12]= { x=240, y=136, xv=0, yv=0, m=4000  , p= 1, accion=false, mobil=true , puntos = 8, tt = 30}
    particula[13]= { x=240, y=136, xv=0, yv=0, m=4000  , p= 1, accion=false, mobil=true , puntos = 8, tt = 30}
    particula[14]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
  elseif Nivel == 8 then
    tiempo_partida = 200 ; tiempo_disparo_1 = 1500 ; tiempo_disparo_2 = 1000
    rep_1 = 4000   ; rep_2 = 9000 ; n_minas = 14   ; num_bolas = 5 ; n_balas_1 = 30 ; n_balas_2 = 30
    particula[1] = { x=10 , y=262, xv=0, yv=0, m=6000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[2] = { x=470, y= 10, xv=0, yv=0, m=4000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[3] = { x= 10, y= 10, xv=0, yv=0, m=6000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[4] = { x=470, y=262, xv=0, yv=0, m=3000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[5] = { x=240, y=136, xv=0, yv=0, m=rep_1 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[6] = { x=240, y=136, xv=0, yv=0, m=rep_2 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[7] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[8] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[9] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[10]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[11]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[12]= { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 8, tt = 30}
    particula[13]= { x=240, y=136, xv=0, yv=0, m=3000  , p= 1, accion=false, mobil=true , puntos = 8, tt = 30}
    particula[14]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
  elseif Nivel == 9 then
    tiempo_partida = 200 ; tiempo_disparo_1 = 1500 ; tiempo_disparo_2 = 1000
    rep_1 = 4000   ; rep_2 = 10000 ; n_minas = 12   ; num_bolas = 5 ; n_balas_1 = 30 ; n_balas_2 = 30
    particula[1] = { x=10 , y=262, xv=0, yv=0, m=7000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[2] = { x=470, y= 10, xv=0, yv=0, m=4000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[3] = { x= 10, y= 10, xv=0, yv=0, m=7000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[4] = { x=470, y=262, xv=0, yv=0, m=2000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[5] = { x=240, y=136, xv=0, yv=0, m=rep_1 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[6] = { x=240, y=136, xv=0, yv=0, m=rep_2 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[7] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[8] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[9] = { x=240, y=136, xv=0, yv=0, m=1000  , p= 1, accion=false, mobil=true , puntos = 1, tt = 8 }
    particula[10]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[11]= { x=240, y=136, xv=0, yv=0, m=1400  , p= 1, accion=false, mobil=true , puntos = 2, tt = 10}
    particula[12]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
    particula[13]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
    particula[14]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
  elseif Nivel == 10 then
    tiempo_partida = 200 ; tiempo_disparo_1 = 1000 ; tiempo_disparo_2 = 1000
    rep_1 = 4000   ; rep_2 = 11000 ; n_minas = 7    ; num_bolas = 6 ; n_balas_1 = 30 ; n_balas_2 = 30
    particula[1] = { x=10 , y=262, xv=0, yv=0, m=7000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[2] = { x=470, y= 10, xv=0, yv=0, m=4000  , p= 0, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[3] = { x= 10, y= 10, xv=0, yv=0, m=7000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[4] = { x=470, y=262, xv=0, yv=0, m=2000  , p= 2, accion=true , mobil=false, puntos = 0, tt = 0 }
    particula[5] = { x=240, y=136, xv=0, yv=0, m=rep_1 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[6] = { x=240, y=136, xv=0, yv=0, m=rep_2 , p= 0, accion=false, mobil=true , puntos = 0, tt = 15}
    particula[7] = { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
    particula[8] = { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
    particula[9] = { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
    particula[10]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
    particula[11]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
    particula[12]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
    particula[13]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
    particula[14]= { x=240, y=136, xv=0, yv=0, m=1500  , p= 1, accion=false, mobil=true , puntos = 4, tt = 15}
  end
end
--------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------
local function funcion_disparo_grabedad()
  if disparo_1 then disparo_1 = false
     if pausa_disp_1 then particula[5].m = rep_1 * 64 ; pausa_disp_1 = false ; tiro_1:play() ; power_1 = 6 end
  else particula[5].m =rep_1  end
  if disparo_2 then disparo_2 = false
     if pausa_disp_2 then particula[6].m = rep_2 * 64 ; pausa_disp_2 = false ; tiro_2:play() ; power_2 = 6 end
  else particula[6].m = rep_2 end
  if disp_1:time() > tiempo_disparo_1 then disp_1:stop() ; disp_1:reset(0) ; pausa_disp_1 = true ; power_1 = 0 end
  if disp_2:time() > tiempo_disparo_2 then disp_2:stop() ; disp_2:reset(0) ; pausa_disp_2 = true ; power_2 = 0 end
end
--------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------
local function funcion_calculos_grabedad()
  for n = 1 , n_particula do 
      for m = n, n_particula do
          if n~=m and particula[n].accion and particula[m].accion then
             atc_n = 0 ; atc_m = 0
             xd = particula[m].x - particula[n].x
             yd = particula[m].y - particula[n].y
             xdabs = math.abs( xd )
             ydabs = math.abs( yd )
             if n == 6 then
                if xdabs < 60 and ydabs < 60 then 
                   if particula[6].x > particula[m].x or particula[6].y > particula[m].y then 
                      if disp_2:time() == 0 then disparo_2 = true ; disp_2:start() end
                   end end end
             if xdabs < 130 and ydabs < 130 then
                if particula[n].p == particula[m].p then
                   if xd > 0 then xp = -1 else xp = 1 end
                   if yd > 0 then yp = -1 else yp = 1 end
                elseif particula[n].p == 0 or particula[m].p == 0  then
                   if xd > 0 then xp = -1 else xp = 1 end
                   if yd > 0 then yp = -1 else yp = 1 end
                else
                   if xd > 0 then xp = 1 else xp = -1 end
                   if yd > 0 then yp = 1 else yp = -1 end end
                d  = math.sqrt( ( xdabs * xdabs ) + ( ydabs * ydabs ) )
                if d < 8 then d = 8 end
                dd = d * d
                xdyd = xdabs + ydabs
                if xdyd == 0 then xdyd = 1 end
                if particula[m].m >= dd then 
                   atc_n = particula[m].m / dd 
                   atx_n =  ( ( atc_n * xdabs ) / xdyd ) * xp    
                   aty_n =  ( ( atc_n * ydabs ) / xdyd ) * yp
                   particula[n].xv = particula[n].xv + atx_n
                   particula[n].yv = particula[n].yv + aty_n
                end
                if particula[n].m >= dd then
                   atc_m = particula[n].m / dd
                   atx_m =  ( ( atc_m * xdabs ) / xdyd ) * xp
                   aty_m =  ( ( atc_m * ydabs ) / xdyd ) * yp
                   particula[m].xv = particula[m].xv - atx_m
                   particula[m].yv = particula[m].yv - aty_m
                end end end end end
end
--------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------
local function funcion_bomba_mina()
  if particula[5].accion then
     for m = n_minas, 14 do
         if particula[m].accion and particula[5].accion then
            x_bomb = math.abs(particula[5].x - particula[m].x)
            y_bomb = math.abs(particula[5].y - particula[m].y)
            bomb = x_bomb + y_bomb
            if bomb < 70 then
               bombbeep:play()
               particula[m].xv = (particula[5].x - particula[m].x)/8
               particula[m].yv = (particula[5].y - particula[m].y)/8
            end
            if bomb < 30 then 
               particula[5].accion = false ; particula[m].accion = false 
               explosion:play() ; repe_5 = true ; jugador_1 = jugador_1 + 8
               if jugador_1 > 99 then jugador_1 = 99 end
            end end end end
  if particula[6].accion then
     for m = n_minas, 14 do
         if particula[m].accion and particula[6].accion then
            x_bomb = math.abs(particula[6].x - particula[m].x)
            y_bomb = math.abs(particula[6].y - particula[m].y)
            bomb = x_bomb + y_bomb
            if bomb < 100 then
               if disp_2:time() == 0 then disparo_2 = true ; disp_2:start() end 
            end
            if bomb < 70 then
               bombbeep:play()
               particula[m].xv = (particula[6].x - particula[m].x)/16
               particula[m].yv = (particula[6].y - particula[m].y)/16
            end
            if bomb < 30 then 
               particula[6].accion = false ; particula[m].accion = false 
               explosion:play() ; repe_6 = true ; jugador_2 = jugador_2 + 8
               if jugador_2 > 99 then jugador_2 = 99 end
            end end end end
end
--------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------
local function funcion_bordes_velocidad_goles_balas()
  ---------------------------
  -- FRENADO EN LOS BORDES --
  ---------------------------
  for n = 5 , n_particula do 
      if particula[n].accion then
         if particula[n].x > 474 then
            if particula[n].xv > 3 then 
               particula[n].xv = particula[n].xv / 1.5 ; particula[n].yv = particula[n].yv / 1.5 end
            particula[n].xv =  particula[n].xv * -1  ; particula[n].x = 468 end
         if particula[n].x < 8   then  
            if particula[n].xv < -3 then 
               particula[n].xv = particula[n].xv / 1.5 ; particula[n].yv = particula[n].yv / 1.5 end
            particula[n].xv =  particula[n].xv * -1  ; particula[n].x = 12 end
         if particula[n].y > 264 then
            if particula[n].yv > 3 then
               particula[n].xv = particula[n].xv / 1.5 ; particula[n].yv = particula[n].yv / 1.5 end
            particula[n].yv =  particula[n].yv * -1  ; particula[n].y = 260  end
         if particula[n].y < 8   then  
            if particula[n].yv < -3 then 
               particula[n].xv = particula[n].xv / 1.5 ; particula[n].yv = particula[n].yv / 1.5 end
            particula[n].yv =  particula[n].yv * -1  ; particula[n].y = 12 end
         ----------------------
         -- LIMITE VELOCIDAD --
         ----------------------
         if n > 6 then
            if particula[n].xv >  16 then particula[n].xv =  16 end
            if particula[n].yv >  16 then particula[n].yv =  16 end
            if particula[n].xv < -16 then particula[n].xv = -16 end
            if particula[n].yv < -16 then particula[n].yv = -16 end
         else
            if particula[n].xv >  14 then particula[n].xv =  14 end
            if particula[n].yv >  14 then particula[n].yv =  14 end
            if particula[n].xv < -14 then particula[n].xv = -14 end
            if particula[n].yv < -14 then particula[n].yv = -14 end
         end
         particula[n].x = particula[n].x + particula[n].xv
         particula[n].y = particula[n].y + particula[n].yv
         if n == 5 and particula[5].x > 240 then particula[5].x = 234 ; particula[5].xv = - 8 end
         if n == 6 and particula[6].x < 240 then particula[6].x = 244 ; particula[6].xv =   8 end end
      ------------------
      -- CUENTA GOLES --
      ------------------
      if particula[n].accion and n > 6 then
         cuenta_particulas = cuenta_particulas + 1
         if particula[n].x < 40 and particula[n].y < 40 then 
            particula[n].accion = false ; gol:play() ; repe_3 = true
            jugador_1 = jugador_1 + particula[n].puntos
            if jugador_1 > 99 then jugador_1 = 99 end end
         if particula[n].x > 440 and particula[n].y > 232 then 
            particula[n].accion = false ; gol:play() ; repe_4 = true
            jugador_2 = jugador_2 + particula[n].puntos
            if jugador_2 > 99 then jugador_2 = 99 end end end
      -----------
      -- BALAS --
      -----------
      if bala_1 and n ~= 5 and particula[n].accion then   
         x_bala_1 = math.abs(bala_1_x - particula[n].x)
         y_bala_1 = math.abs(bala_1_y - particula[n].y)
         xy_bala_1 = x_bala_1 + y_bala_1
         if xy_bala_1 < ( 10 + particula[n].tt ) then
            bala_1_x = particula[n].x - 30
            bala_1_y = particula[n].y - 30
            if n == 6 then jugador_2 = jugador_2 + 8 end
            if jugador_2 > 99 then jugador_2 = 99 end
            particula[n].accion = false ; bala_1 = false ; fuego_1 = false
            explosion:play() ; repe_10 = true end end
      if bala_2 and n ~= 6 and particula[n].accion then   
         x_bala_2 = math.abs(bala_2_x - particula[n].x)
         y_bala_2 = math.abs(bala_2_y - particula[n].y)
         xy_bala_2 = x_bala_2 + y_bala_2
         if xy_bala_2 < ( 10 + particula[n].tt ) then
            bala_2_x = particula[n].x - 30
            bala_2_y = particula[n].y - 30
            if n == 5 then jugador_1 = jugador_1 + 8 end
            if jugador_1 > 99 then jugador_1 = 99 end
            particula[n].accion = false ; bala_2 = false ; fuego_2 = false
            explosion:play() ; repe_11 = true end end
  end
end
--------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------
local function funcion_saca_bolas()
  if tiempo_bolas:time() > 2000 then
     if not particula[5].accion and not repe_5 then 
        particula[5].accion = true
        particula[5].x = 60  ; particula[5].y = 60
        particula[5].xv = 0  ; particula[5].yv = 0 ; repe_8 = true ; saque:play()
     end
     if not particula[6].accion and not repe_6 then 
        particula[6].accion = true
        particula[6].x = 425 ; particula[6].y = 217 
        particula[6].xv = 0  ; particula[6].yv = 0 ; repe_9 = true ; saque:play()
     end
     if cuenta_particulas < num_bolas then
        if bola > 6 and not particula[bola].accion then
           particula[bola].accion = true
           particula[bola].x = 240 ; particula[bola].y = 136
           particula[bola].xv = math.random( -4 , 4 )
           particula[bola].yv = math.random( -4 , 4 )
           if particula[bola].xv == 0 then particula[bola].xv = math.random( -4 , 4 ) end
           if particula[bola].yv == 0 then particula[bola].yv = math.random( -4 , 4 ) end
           repe_7 = true ; saque:play()  end
        bola = bola + 1 end
     if bola > 14 then bola = 6 end
     tiempo_bolas:reset(0) ; tiempo_bolas:start()
  end
end
--------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------
local function funcion_pinta_sprites()
  screen:blit( 0, 0, paisaje)
  screen:blit( 0, 0, fondo[fo2])
  if disparo_1 and pausa_disp_1 then repe_1 = true end
  if disparo_2 and pausa_disp_2 then repe_2 = true end
  if repe_7 then
     if fo == 1 or fo == 4 or cuenta_repe_7 == 0 then cuenta_repe_7 = cuenta_repe_7 + 1 end
     if   cuenta_repe_7 > 4 then cuenta_repe_7 = 0 ; repe_7 = false
     else screen:blit( 176 , 72 , vortice[cuenta_repe_7]) end end
  if repe_8 then
     if fo == 1 or fo == 4 or cuenta_repe_8 == 0 then cuenta_repe_8 = cuenta_repe_8 + 1 end
     if   cuenta_repe_8 > 4 then cuenta_repe_8 = 0 ; repe_8 = false
     else screen:blit( -4 , -4 , vortice[cuenta_repe_8]) end end
  if repe_9 then
     if fo == 1 or fo == 4 or cuenta_repe_9 == 0 then cuenta_repe_9 = cuenta_repe_9 + 1 end
     if   cuenta_repe_9 > 4 then cuenta_repe_9 = 0 ; repe_9 = false
     else screen:blit( 360 , 150 , vortice[cuenta_repe_9]) end end
  if repe_1 then cuenta_repe_1 = cuenta_repe_1 + 1
     if   cuenta_repe_1 > 6 then cuenta_repe_1 = 0 ; repe_1 = false
     else screen:blit( particula[5].x - 40 , particula[5].y - 40 , barrera[cuenta_repe_1]) end end
  if repe_2 then cuenta_repe_2 = cuenta_repe_2 + 1
     if   cuenta_repe_2 > 6 then cuenta_repe_2 = 0 ; repe_2 = false
     else screen:blit( particula[6].x - 40 , particula[6].y - 40 , barrera[cuenta_repe_2]) end end
  if repe_3 then cuenta_repe_3 = cuenta_repe_3 + 1
     if   cuenta_repe_3 > 16 then cuenta_repe_3 = 0 ; repe_3 = false
     else screen:blit( -4, -4 , bumb[cuenta_repe_3]) end end
  if repe_4 then cuenta_repe_4 = cuenta_repe_4 + 1
     if   cuenta_repe_4 > 16 then cuenta_repe_4 = 0 ; repe_4 = false
     else screen:blit( 424, 216 , bumb[cuenta_repe_4]) end end
  if jugador_1 < 10 then screen:print(17,  17, jugador_1 , amarillo)
  else screen:print(13,  17, jugador_1 , amarillo) end
  if jugador_2 < 10 then screen:print(457,249, jugador_2 , amarillo)
  else screen:print(453,249, jugador_2 , amarillo) end
  screen:print(210,3, "Tiempo:" .. tiempo_partida, amarillo )
  for n = 5 , n_particula do
      if particula[n].accion then
         if     n == 5  then screen:blit( particula[5].x  - particula[5].tt , particula[5].y  - particula[5].tt , j1[fo+power_1])
         elseif n == 6  then screen:blit( particula[6].x  - particula[6].tt , particula[6].y  - particula[6].tt , j2[fo+power_2])
         elseif n == 7  then screen:blit( particula[7].x  - particula[7].tt , particula[7].y  - particula[7].tt , a2[fo3])
         elseif n == 8  then screen:blit( particula[8].x  - particula[8].tt , particula[8].y  - particula[8].tt , a2[fo3])
         elseif n == 9  then screen:blit( particula[9].x  - particula[9].tt , particula[9].y  - particula[9].tt , a2[fo4])
         elseif n == 10 then screen:blit( particula[10].x - particula[10].tt, particula[10].y - particula[10].tt, a1[fo4])
         elseif n == 11 then screen:blit( particula[11].x - particula[11].tt, particula[11].y - particula[11].tt, a1[fo3])
         elseif n == 12 then screen:blit( particula[12].x - particula[12].tt, particula[12].y - particula[12].tt, a3[fo3])
         elseif n == 13 then screen:blit( particula[13].x - particula[13].tt, particula[13].y - particula[13].tt, a3[fo4])
         elseif n == 14 then screen:blit( particula[14].x - particula[14].tt, particula[14].y - particula[14].tt, a4[fo4])
         end end end
  if repe_5 then cuenta_repe_5 = cuenta_repe_5 + 1
     if   cuenta_repe_5 > 16 then cuenta_repe_5 = 0 ; repe_5 = false
     else screen:blit( particula[5].x - 30 , particula[5].y - 30 , bumb[cuenta_repe_5]) end end
  if repe_6 then cuenta_repe_6 = cuenta_repe_6 + 1
     if   cuenta_repe_6 > 16 then cuenta_repe_6 = 0 ; repe_6 = false
     else screen:blit( particula[6].x - 30 , particula[6].y - 30 , bumb[cuenta_repe_6]) end end
  if repe_10 then cuenta_repe_10 = cuenta_repe_10 + 1
     if   cuenta_repe_10 > 16 then cuenta_repe_10 = 0 ; repe_10 = false
     else screen:blit( bala_1_x , bala_1_y , bumb[cuenta_repe_10]) end end

  if repe_11 then cuenta_repe_11 = cuenta_repe_11 + 1
     if   cuenta_repe_11 > 16 then cuenta_repe_11 = 0 ; repe_11 = false
     else screen:blit( bala_2_x , bala_2_y , bumb[cuenta_repe_11]) end end
end
--------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------
local function funcion_pinta_balas()
  if fuego_1  then
     if not bala_1 then 
        bala_1_x = particula[5].x + 18
        bala_1_y = particula[5].y
        bala_1   = true
        fire_1:play()
        n_balas_1 = n_balas_1 - 1
     else bala_1_x = bala_1_x + 18 end
     screen:blit( bala_1_x - 3 , bala_1_y - 3 , bala[fo])
     if bala_1_x > 480 then fuego_1 = false ; bala_1 = false end end
  if fuego_2 then
     if not bala_2 then 
        bala_2_x = particula[6].x - 18
        bala_2_y = particula[6].y
        bala_2   = true
        fire_2:play()
        n_balas_2 = n_balas_2 - 1
     else bala_2_x = bala_2_x - 18 end
     screen:blit( bala_2_x - 3 , bala_2_y - 3 , bala[fo])
     if bala_2_x < 0 then fuego_2 = false ; bala_2 = false end end
end
--------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------
local function funcion_muestra_pantalla()
  screen.waitVblankStart()
  screen.flip()
  fo = fo + 1
  if fo > 6 then fo = 1 end
  fo1 = fo1 + 1
  if fo1 > 2 then fo1 = 1 ; fo2 = fo2 + 1 end
  if fo2 > 6 then fo2 = 1 ; fo3 = fo3 + 1 end
  if fo3 > 6 then fo3 = 1 ; fo4 = fo4 + 1 end
  if fo4 > 6 then fo4 = 1 end
end
--------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------
local function funcion_seleccion_nivel()
  Nivel = oldNivel
  if Nivel == 0 then Nivel = 1 end
  local fin_seleccion = false
  local seleccion_nivel = Image.load("./Comun/Selector_Nivel.png")
  local miniatura = Image.load("./Nivel_"..Nivel.."/miniatura.png")
  screen:blit(   0,   0, seleccion_nivel)
  screen:blit( 181, 120, miniatura)
  screen:fontPrint( fuente_m , 181, 110 , "Nivel - ".. Nivel , amarillo)
  screen.flip() ; screen.waitVblankStart(20)
  repeat
    pad = Controls.read()
    if pad:right() then 
       Nivel = Nivel + 1 ; if Nivel > 10 then Nivel = 1 end 
       miniatura = Image.load("./Nivel_"..Nivel.."/miniatura.png")
       screen:blit(   0,   0, seleccion_nivel)
       screen:blit( 181, 120, miniatura)
       screen:fontPrint( fuente_m , 181, 110 , "Nivel - ".. Nivel , amarillo)
       screen.flip() ; screen.waitVblankStart(10) end
    if pad:up() then 
       Nivel = Nivel + 1 ; if Nivel > 10 then Nivel = 1 end 
       miniatura = Image.load("./Nivel_"..Nivel.."/miniatura.png")
       screen:blit(   0,   0, seleccion_nivel)
       screen:blit( 181, 120, miniatura)
       screen:fontPrint( fuente_m , 181, 110 , "Nivel - ".. Nivel , amarillo)
       screen.flip() ; screen.waitVblankStart(10) end
    if pad:left() then 
       Nivel = Nivel - 1 ; if Nivel < 1 then Nivel = 10 end 
       miniatura = Image.load("./Nivel_"..Nivel.."/miniatura.png")
       screen:blit(   0,   0, seleccion_nivel)
       screen:blit( 181, 120, miniatura)
       screen:fontPrint( fuente_m , 181, 110 , "Nivel - ".. Nivel , amarillo)
       screen.flip() ; screen.waitVblankStart(10) end
    if pad:down() then 
       Nivel = Nivel - 1 ; if Nivel < 1 then Nivel = 10 end 
       miniatura = Image.load("./Nivel_"..Nivel.."/miniatura.png")
       screen:blit(   0,   0, seleccion_nivel)
       screen:blit( 181, 120, miniatura)
       screen:fontPrint( fuente_m , 181, 110 , "Nivel - ".. Nivel , amarillo)
       screen.flip() ; screen.waitVblankStart(10) end
    if pad:cross()    then fin_seleccion = true end
    if pad:circle()   then fin_seleccion = true end
    if pad:triangle() then Nivel = 1 ; fin_seleccion = true ; fin_partida = true end
    if pad:square()   then Nivel = 1 ; fin_seleccion = true ; fin_partida = true end
    if pad:start()    then Nivel = 1 ; fin_seleccion = true ; fin_partida = true end
    if pad:select()   then Nivel = 1 ; fin_seleccion = true ; fin_partida = true end
    screen.waitVblankStart(1)
  until fin_seleccion
  screen.waitVblankStart(20)
end
--------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------
local function funcion_reiniciar_nivel()
  generar_particulas()
  bola = 6 ; jugador_1 = 0 ; jugador_2 = 0
  tiempo:reset(0) ; tiempo:start() ; tiempo_bolas:reset(0) ; tiempo_bolas:start()
end
--------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------
local function funcion_pausa()
  Music.pause()
  local opcion = 1
  local fin_seleccion = false
  local function pinta_pausa()
    screen:clear(negro)
    screen:fontPrint( fuente_m ,15, 40, "--------------------------------------" , amarillo)
    screen:fontPrint( fuente_m ,15, 58, "        * * *   PAUSA   * * *         " , amarillo)
    screen:fontPrint( fuente_m ,15, 76, "--------------------------------------" , amarillo)
    screen:fontPrint( fuente_m ,15,112, "         Continuar Nivel Actual.      " , amarillo)
    screen:fontPrint( fuente_m ,15,130, "         Reiniciar Nivel Actual.      " , amarillo)
    screen:fontPrint( fuente_m ,15,148, "         Cargar  otro  Nivel.         " , amarillo)
    screen:fontPrint( fuente_m ,15,166, "         Abandonar  el Juego.         " , amarillo)
    screen:fontPrint( fuente_m ,15,202, "--------------------------------------" , amarillo)
    if opcion == 1 then screen:fontPrint( fuente_m ,15,112, "  ----->" , amarillo) end
    if opcion == 2 then screen:fontPrint( fuente_m ,15,130, "  ----->" , amarillo) end
    if opcion == 3 then screen:fontPrint( fuente_m ,15,148, "  ----->" , amarillo) end
    if opcion == 4 then screen:fontPrint( fuente_m ,15,166, "  ----->" , amarillo) end
    screen.flip()
    screen.waitVblankStart(20)
  end
  pinta_pausa() ; screen.waitVblankStart(10)
  repeat
    pad = Controls.read()
    if pad:right() then 
       opcion = opcion + 1 ; if opcion > 4 then opcion = 1 end
       pinta_pausa() end
    if pad:left() then 
       opcion = opcion - 1 ; if opcion < 1 then opcion = 4 end
       pinta_pausa() end
    if pad:up() then 
       opcion = opcion - 1 ; if opcion < 1 then opcion = 4 end
       pinta_pausa() end
    if pad:down() then 
       opcion = opcion + 1 ; if opcion > 4 then opcion = 1 end 
       pinta_pausa() end
    if pad:cross()  then fin_seleccion = true end
    if pad:circle() then fin_seleccion = true end
    screen.waitVblankStart(1)
  until fin_seleccion
  if opcion == 1 then Music.resume() end
  if opcion == 2 then Music.resume() ; funcion_reiniciar_nivel() end
  if opcion == 3 then Music.stop()   ; fin = true ; oldNivel = Nivel ; Nivel = 0 end
  if opcion == 4 then Music.stop()   ; fin = true ; fin_partida = true end
  screen.waitVblankStart(20)
end
--------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------
local function funcion_tierra_salvada()
  fin = true
  fondo[1] = Image.load("./Comun/tierra_salvada.png")
  screen:blit(0,0,fondo[1]) ; screen.flip() 
  screen.waitVblankStart(60)
  screen:blit(0,0,fondo[1])
  screen:fillRect(165, 238, 140, 30, negro)
  screen:fontPrint( fuente_m , 170, 260, "- Pulse X -" , amarillo )
  screen.flip()
  while fin do
    pad = Controls.read()
    if pad:cross()    then fin = false end
    screen.waitVblankStart(2)
 end
 screen.waitVblankStart(20)
 fin = true
end
--------------------------------------------------------------------------------------------------------------
 
--------------------------------------------------------------------------------------------------------------
local function funcion_tierra_destruida()
  fin = true
  fondo[1] = Image.load("./Comun/tierra_destruida.png")
  screen:blit(0,0,fondo[1]) ; screen.flip() 
  screen.waitVblankStart(60)
  screen:blit(0,0,fondo[1]) 
  screen:fillRect(165, 238, 140, 30, negro)
  screen:fontPrint( fuente_m , 170, 260, "- Pulse X -" , amarillo )
  screen.flip()
  while fin do
    pad = Controls.read()
    if pad:cross()    then fin = false end
    screen.waitVblankStart(2)
 end
 screen.waitVblankStart(20)
 fin = true
end
--------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------
-- FIN FUNCIONES -------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------













------------------------------------------------------------------------------------------------
-- JUEGO ---------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------
repeat -- fin_partida
 math.randomseed(os.time())
 fin = false
 if Nivel < 1 or Nivel > 10 then funcion_seleccion_nivel() end
 if fin_partida then break end
 funcion_cargar_imagenes()
 generar_particulas()
 bola = 6              ; jugador_1 = 0         ; jugador_2 = 0
 tiempo_bolas:reset(0) ; tiempo_bolas:start()  ; tiempo:reset(0) ; tiempo:start()
 
repeat -- fin

  cuenta_particulas = 0
  funcion_disparo_grabedad()
  funcion_calculos_grabedad()
  funcion_bomba_mina()
  funcion_bordes_velocidad_goles_balas()
  funcion_saca_bolas()

  ------------------------------------------------------------------------------------
  -- CONTROLES JUGADORES -------------------------------------------------------------
  ------------------------------------------------------------------------------------
  pad = Controls.read()

  if particula[5].accion then
     particula[5].xv = particula[5].xv / 1.3
     particula[5].yv = particula[5].yv / 1.3

     if     pad:right() and oldpad:right() then particula[5].xv = particula[5].xv + 6
     elseif pad:right()                    then particula[5].xv = particula[5].xv + 3 end

     if     pad:left() and oldpad:left() then particula[5].xv = particula[5].xv - 6
     elseif pad:left()                   then particula[5].xv = particula[5].xv - 3 end

     if     pad:down() and oldpad:down() then particula[5].yv = particula[5].yv + 6 
     elseif pad:down()                   then particula[5].yv = particula[5].yv + 3 end

     if     pad:up() and oldpad:up() then particula[5].yv = particula[5].yv - 6 
     elseif pad:up()                 then particula[5].yv = particula[5].yv - 3 end
     
     if pad:analogX() >  60 then particula[5].xv = particula[5].xv + 3 end
     if pad:analogY() >  60 then particula[5].yv = particula[5].yv + 3 end
     if pad:analogX() < -60 then particula[5].xv = particula[5].xv - 3 end
     if pad:analogY() < -60 then particula[5].yv = particula[5].yv - 3 end
     if pad:analogX() >  99 then particula[5].xv = particula[5].xv + 6 end
     if pad:analogY() >  99 then particula[5].yv = particula[5].yv + 6 end
     if pad:analogX() < -99 then particula[5].xv = particula[5].xv - 6 end
     if pad:analogY() < -99 then particula[5].yv = particula[5].yv - 6 end

     if pad:cross()  then if disp_1:time() == 0 then disparo_1 = true ; disp_1:start() end  end
     if pad:circle() then if not repe_10 and n_balas_1 > 0 then fuego_1 = true end  end
  end

  if pad:select() then funcion_pausa() end
  if pad:start()  then funcion_pausa() end

  oldpad = Controls.read()

  if fin then break end

  if particula[6].accion then
     
     if particula[5].accion then
        if not repe_11 and n_balas_2 > 0 then 
           if math.abs (particula[6].y - particula[5].y ) < 15 then 
              if math.random(1,8) == 4 then fuego_2 = true end end end end

     if math.random(1,8) == 4 then
        if particula[6].x < 260 then particula[6].xv = math.random(  6 , 8 )
        else particula[6].xv = particula[6].xv + math.random( -6 , 6 ) end
        if particula[6].y < 150 then particula[6].yv = math.random(  6 , 8 )
        else particula[6].yv = particula[6].xv + math.random( -6 , 6 ) end end

     if fuego_1 then 
        if math.abs(bala_1_y - particula[6].y) < 60 then
           if math.abs(bala_1_x - particula[6].x) < 80 then
              if bala_1_y >= particula[6].y then
                 particula[6].y =  particula[6].y - 6
              else
                 particula[6].y =  particula[6].y + 6 end end end end end

  ------------------------------------------------------------------------------------
  -- FIN CONTROLES JUGADORES ---------------------------------------------------------
  ------------------------------------------------------------------------------------

  funcion_pinta_sprites()
  funcion_pinta_balas()
  funcion_muestra_pantalla()
  screen.waitVblankStart(2)

  -------------------------------------------------------------------------------------------
  -- FIN PARTIDA ----------------------------------------------------------------------------
  -------------------------------------------------------------------------------------------
  if jugador_1 > 98 or jugador_2 > 98 or  tiempo_partida <= 0 then
      
     repe_1 = false ; repe_2 = false ; repe_7 = false ; repe_8 = false ; repe_9 = false
     fuego_1 = false; fuego_2 = false
     cuenta_repe_1 = 0 ; cuenta_repe_2 = 0 ; cuenta_repe_7 = 0 ; cuenta_repe_8 = 0 ; cuenta_repe_9 = 0
 
     tiempo:stop() ; tiempo_final:reset(0);  tiempo_final:start()

     while tiempo_final:time() < 8000  do

       if jugador_1 < jugador_2 then 
          if not repe_4 then repe_4 = true end
          if particula[6].accion then repe_6 = true ; particula[6].accion = false end
       else 
          if not repe_3 then repe_3 = true end
          if particula[5].accion then repe_5 = true ; particula[5].accion = false end 
       end

       funcion_pinta_sprites()

       if jugador_1 < jugador_2 then screen:fillRect(112, 114, 254, 34, negro)
            screen:fontPrint( fuente_m ,120,136, "GANADOR JUGADOR ROJO" , rojo )
            screen:fillRect(165, 202, 140, 34, negro)
            screen:fontPrint( fuente_m , 175, 224, "VIDAS -> " .. Vidas , amarillo )
       else 
            screen:fillRect(112, 114, 254, 34, negro)
            screen:fontPrint( fuente_m ,120,136, "GANADOR JUGADOR AZUL" , azul)
            screen:fillRect(165, 202, 140, 34, negro)
            screen:fontPrint( fuente_m , 175, 224, "VIDAS -> " .. Vidas - 1 , amarillo )
       end

       if tiempo_final:time() > 2000 then
          pad = Controls.read()
          if pad:cross() then break end end

       funcion_muestra_pantalla()
       screen.waitVblankStart(2)

     end

     if jugador_1 < jugador_2 then
        Nivel = Nivel + 1 ; fin = true
     else
        Vidas = Vidas - 1
        if Vidas == 0 then 
           funcion_tierra_destruida()
           Vidas = 3 ; Nivel = 0 ; fin = true
        else
          funcion_reiniciar_nivel()
        end end

     if Nivel > 10 then Vidas = 3 ; funcion_tierra_salvada() end   

  end
  -------------------------------------------------------------------------------------------
  -- FIN FIN PARTIDA ------------------------------------------------------------------------
  -------------------------------------------------------------------------------------------
  
  if tiempo:time() > 1000 then  
     tiempo_partida = tiempo_partida - 1
     tiempo:reset(0) ; tiempo:start()
  end

until fin
Music.stop()
screen.waitVblankStart(10)

until fin_partida
----------------------------------------------------------------------------------------------
-- FIN JUEGO ---------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
